#ifndef EFL_GENERATED_ECORE_AUDIO_IN_TONE_HH
#define EFL_GENERATED_ECORE_AUDIO_IN_TONE_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "ecore_audio_in_tone.eo.h"
}

#include "ecore_audio_in.eo.hh"

struct ecore_audio_in_tone;

namespace eo_cxx {

struct ecore_audio_in_tone
{

   static Eo_Class const* _eo_class()
   {
      return(ECORE_AUDIO_IN_TONE_CLASS);
   }

   operator ::ecore_audio_in_tone() const;
   operator ::ecore_audio_in_tone&();
   operator ::ecore_audio_in_tone const&() const;

   template <typename D>
   struct address_of
   {
      operator ::ecore_audio_in_tone*() const { return static_cast<::ecore_audio_in_tone*>(static_cast<D const*>(this)->p); }
      operator ::ecore_audio_in_tone const*() const { return static_cast<::ecore_audio_in_tone const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::ecore_audio_in_tone const*() const { return static_cast<::ecore_audio_in_tone const*>(static_cast<D const*>(this)->p); }
   };

private:
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}

struct ecore_audio_in_tone
      : ::efl::eo::concrete
      , ::eo_cxx::ecore_audio
      , ::eo_cxx::ecore_audio_in
      , ::eo_cxx::eo::base
{
   ecore_audio_in_tone(::efl::eo::parent_type _p = (::efl::eo::parent = nullptr))
      : ecore_audio_in_tone(_ctors_call(_p))
   {}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit ecore_audio_in_tone(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit ecore_audio_in_tone(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   ecore_audio_in_tone(ecore_audio_in_tone const& other)
      : ecore_audio_in_tone(eo_ref(other._eo_ptr()))
   {}

   ~ecore_audio_in_tone() {}


   static Eo_Class const* _eo_class()
   {
      return(ECORE_AUDIO_IN_TONE_CLASS);
   }

   struct address_of
      : ::eo_cxx::ecore_audio_in_tone::address_of<address_of>
      , ::eo_cxx::ecore_audio::address_of<address_of>
      , ::eo_cxx::ecore_audio_in::address_of<address_of>
      , ::eo_cxx::eo::base::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::ecore_audio_in_tone* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::ecore_audio_in_tone::address_const_of<address_const_of>
      , ::eo_cxx::ecore_audio::address_const_of<address_const_of>
      , ::eo_cxx::ecore_audio_in::address_const_of<address_const_of>
      , ::eo_cxx::eo::base::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::ecore_audio_in_tone const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

private:
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(ECORE_AUDIO_IN_TONE_CLASS, _p._eo_raw, );

      return _ret_eo;
   }

      Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::ecore_audio_in_tone) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::ecore_audio_in_tone>::value, "");

inline ::eo_cxx::ecore_audio_in_tone::operator ::ecore_audio_in_tone() const
{
   return *static_cast<::ecore_audio_in_tone const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::ecore_audio_in_tone::operator ::ecore_audio_in_tone&()
{
   return *static_cast<::ecore_audio_in_tone*>(static_cast<void*>(this));
}

inline ::eo_cxx::ecore_audio_in_tone::operator ::ecore_audio_in_tone const&() const
{
   return *static_cast<::ecore_audio_in_tone const*>(static_cast<void const*>(this));
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::ecore_audio_in_tone >
{
   template <typename T>
   struct type
         : virtual operations< ::ecore_audio_in >::template type<T>
   {
   };
};


template<>
struct operation_description_class_size< ::ecore_audio_in_tone >
{
   static const int value = 0 + operation_description_class_size<::ecore_audio_in >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::ecore_audio_in_tone>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   initialize_operation_description<T>(::efl::eo::detail::tag<::ecore_audio_in>(), &ops[0]);
   return 0;
}
inline void
call_constructor(::efl::eo::detail::tag< ::ecore_audio_in_tone >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               ::efl::eo::detail::args_class<::ecore_audio_in_tone, ::std::tuple<::efl::eo::parent_type> > const& args)
{
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

inline Eo_Class const* get_eo_class(tag<::ecore_audio_in_tone>)
{
   return (ECORE_AUDIO_IN_TONE_CLASS);
}

} } }
#endif // EFL_GENERATED_ECORE_AUDIO_IN_TONE_HH

